from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

# OpenGL toolkit

def RenderScene():
    """ Called to draw scene """
    # Clear the window with current clearing color 
    glClear(GL_COLOR_BUFFER_BIT)
    
    # Set current drawing color to red # R G B 
    glColor3f(1.0, 0.0, 0.0)

    # Draw a filled rectangle with current color 
    glRectf(-25.0, 25.0, 25.0, -25.0)

    # Flush drawing commands 
    glFlush() 

def SetupRC():
    """ Set up the rendering state """
    # Set clear color to blue 
    glClearColor(0.0, 0.0, 1.0, 1.0) 

def ChangeSize(w, h):
    """ Called by GLUT library when the window has changed size """
    # Prevent a divide by zero 
    if(h == 0): h = 1

    # Set Viewport to window dimensions 
    glViewport(0, 0, w, h)

    # Reset coordinate system 
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()

    # Establish clipping volume (left, right, bottom, top, near, far) 
    aspectRatio = float(w) / float(h) 
    if (w <= h):
        glOrtho (-100.0, 100.0, -100 / aspectRatio,
                 100.0 / aspectRatio, 1.0, -1.0)
    else: 
        glOrtho (-100.0 * aspectRatio, 100.0 * aspectRatio,
                 -100.0, 100.0, 1.0, -1.0)

    glMatrixMode(GL_MODELVIEW) 
    glLoadIdentity() 

# Main program entry point 

if __name__ == "__main__":
    glutInit() 
    glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB) 
    glutCreateWindow("GLRect") 
    glutDisplayFunc(RenderScene) 
    glutReshapeFunc(ChangeSize) 
    SetupRC()
    glutMainLoop() 
