from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *
from math import *

# Rotation amounts
xRot = 0.0
yRot = 0.0

view3 = (0.0, 0.0, 6.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0)
view4 = (3.0, 0.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0)
view1 = (3.0, 2.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0)
view2 = (5.0, 5.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0)
winwidth, winheigth = 0, 0


def init():
    glClearColor(1.0, 1.0, 1.0, 1.0)
    glColor3f(0.0, 0.0, 1.0)
    glShadeModel(GL_FLAT)
    glEnable(GL_SCISSOR_TEST)
    glEnable(GL_DEPTH_TEST)

def scenemodel():
    global xRot, yRot

    # Save matrix state and do the rotation
    glPushMatrix()
    glRotatef(xRot, 1.0, 0.0, 0.0)
    glRotatef(yRot, 0.0, 1.0, 0.0)
    
    glScalef(1.5, 1.5, 1.5) #/* modeling transformation */
    glBegin(GL_QUADS);
    glColor3f(0.0,1.0,0.0)
    glVertex3f( 1.0, 1.0,-1.0)
    glVertex3f(-1.0, 1.0,-1.0)
    glVertex3f(-1.0, 1.0, 1.0)
    glVertex3f( 1.0, 1.0, 1.0)
    glColor3f(1.0,0.5,0.0)
    glVertex3f( 1.0,-1.0, 1.0)
    glVertex3f(-1.0,-1.0, 1.0)
    glVertex3f(-1.0,-1.0,-1.0)
    glVertex3f( 1.0,-1.0,-1.0)
    glColor3f(1.0,0.0,0.0)
    glVertex3f( 1.0, 1.0, 1.0)
    glVertex3f(-1.0, 1.0, 1.0)
    glVertex3f(-1.0,-1.0, 1.0)
    glVertex3f( 1.0,-1.0, 1.0)
    glColor3f(1.0,1.0,0.0)
    glVertex3f( 1.0,-1.0,-1.0)
    glVertex3f(-1.0,-1.0,-1.0)
    glVertex3f(-1.0, 1.0,-1.0)
    glVertex3f( 1.0, 1.0,-1.0)
    glColor3f(0.0,0.0,1.0)
    glVertex3f(-1.0, 1.0, 1.0)
    glVertex3f(-1.0, 1.0,-1.0)
    glVertex3f(-1.0,-1.0,-1.0)
    glVertex3f(-1.0,-1.0, 1.0)
    glColor3f(1.0,0.0,1.0)
    glVertex3f( 1.0, 1.0,-1.0)
    glVertex3f( 1.0, 1.0, 1.0)
    glVertex3f( 1.0,-1.0, 1.0)
    glVertex3f( 1.0,-1.0,-1.0)
    glEnd()

    glPushMatrix()
    glScalef(2, 2, 2)
    glColor3f(1.0, 1.0, 1.0)
    glutWireCube(1.0)
    glPopMatrix()

    # Restore transformations
    glPopMatrix()

    # Flush drawing commands
    glutSwapBuffers()
    
def Display():
        
    global view1,view2,view3,view4
    global winwidth,winheigth
    w,h = winwidth,winheigth
    aspectRatio = float(w) / float(h) 
    if (w <= h): u,v = 1,1/aspectRatio
    else: u,v = aspectRatio, 1

    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    glFrustum(-1.0*u, 1.0*u, -1.0*v, 1.0*v, 1.5, 10.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity() 
    
    glScissor(0, 0, w/2, h/2)
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    glViewport(0, 0, w/2, h/2)
    glLoadIdentity()
    gluLookAt(*view1)
    scenemodel()
    
    glScissor(0, h/2, w/2, h/2)
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    glViewport(0, h/2, w/2, h/2)
    glLoadIdentity()
    gluLookAt(*view3)
    scenemodel()
    
    glScissor(w/2, h/2, w/2, h/2)
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    glViewport(w/2, h/2, w/2, h/2)
    glLoadIdentity()
    gluLookAt(*view4)
    scenemodel()

    glScissor(w/2, 0, w/2, h/2)
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    glViewport(w/2, 0, w/2, h/2)
    glMatrixMode(GL_PROJECTION)
    glPushMatrix()
    glLoadIdentity()
    glOrtho(-4.0*u, 4.0*u, -4.0*v, 4.0*v, 0.1, 100.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
    gluLookAt(*view2)
    scenemodel()
    glMatrixMode(GL_PROJECTION)
    glPopMatrix()
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()

    glutSwapBuffers()


def Reshape(w, h):
    global view1,view2,view3,view4
    global winwidth,winheigth
    winwidth,winheigth = w,h
    Display()


def SpecialKeys(key, x, y):
    global xRot, yRot
    if(key == GLUT_KEY_UP): xRot-= 5.0
    elif(key == GLUT_KEY_DOWN): xRot += 5.0
    elif(key == GLUT_KEY_LEFT): yRot -= 5.0
    elif(key == GLUT_KEY_RIGHT): yRot += 5.0
    elif(key > 356.0): xRot = 0.0
    elif(key < -1.0): xRot = 355.0
    elif(key > 356.0): yRot = 0.0
    elif(key < -1.0): yRot = 355.0
    # Refresh the Window
    glutPostRedisplay()

 

# Main program entry point
if __name__ == "__main__":
    glutInit()
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH)
    glutInitWindowSize(500, 500)
    glutInitWindowPosition(940, 0)
    glutCreateWindow("cube")
    init()
    glutDisplayFunc(Display)
    glutSpecialFunc(SpecialKeys)
    glutReshapeFunc(Reshape)
    glutMainLoop()
